## ros-foxy-ifopt 2.1.2

=== CMakeLists.txt ===
# Copyright (c) 2017, Alexander W. Winkler, ETH Zurich. All rights reserved.
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(ifopt VERSION 2.0.6)

if(WIN32)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

###########
## Build ##
###########
include(GNUInstallDirs) # for correct library locations across platforms
set(config_package_location "share/${PROJECT_NAME}/cmake") # for .cmake find-scripts installs
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)             # so installed solver libraries link to IFOPT/SNOPT                                          
set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib)    # so installed solver libraries link to libifopt_core.so  
set(IFOPT_INSTALL_BINDIR ${CMAKE_INSTALL_LIBDIR}/ifopt) # replicate default for catkin installs

IF(NOT CMAKE_BUILD_TYPE MATCHES Release)
  message(STATUS "CMAKE_BUILD_TYPE not set to Release -> impacts performance")
endif()

enable_testing()
set(LIB_CORE ifopt_core)
add_subdirectory(ifopt_core)

option(BUILD_IPOPT "compile with IPOPT solver" ON)
if (BUILD_IPOPT)
  add_subdirectory(ifopt_ipopt)
endif()

option(BUILD_SNOPT "compile with SNOPT solver" OFF)
if (BUILD_SNOPT)
  add_subdirectory(ifopt_snopt)
endif()


##################################################
## Install find scripts for find_package(ifopt) ##
##################################################
# generate the file IfoptConfigVersion.cmake
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/ifopt-config-version.cmake"
  VERSION ${ifopt_VERSION}
  COMPATIBILITY SameMajorVersion
)
# install the two files in a place where cmake looks for them
install(
  FILES 
    "${CMAKE_CURRENT_SOURCE_DIR}/ifopt-config.cmake"         # self-written
    "${CMAKE_CURRENT_BINARY_DIR}/ifopt-config-version.cmake" # generated
  DESTINATION ${config_package_location}
)
# Install a Catkin 'package.xml' file. This is required by REP-136.
install(FILES package.xml DESTINATION share/${PROJECT_NAME})

=== debian/changelog ===
ros-foxy-ifopt (2.1.2-1focal) focal; urgency=high

  * Expose epsilon for cost gradient finite difference approximation
  * Contributors: Levi Armstrong

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 29 Nov 2021 06:00:00 -0000

ros-foxy-ifopt (2.1.1-1focal) focal; urgency=high

  * replace static variable falsely shared between contraints and costs
  * Reduce calls to GetJacobian
  * Changes to support windows build (#65)
  * set default parameter or finite diff for backwards compatibility
  * add return-status getter also to SNOPT
  * calculate finite difference of cost-term for IPOPT if flag set. (#61)
  * add explanation setting jacobian sparsity pattern (#47) (#55)
  * Update README.md
  * Switch  between catkin and ament based on ROS_VERSION (#52)
  * Add GetConstraints and GetCosts to Problem (#51)
  * Add GetJacobianOfCosts to Problem (#50)
  * Make FillJacobianBlock public in ConstraintSet (#49)

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 15 Nov 2021 06:00:00 -0000

ros-foxy-ifopt (2.0.7-1focal) focal; urgency=high

  * Create function to get the time statistics and the return code from the optimization solver. (#40 <https://github.com/ethz-adrl/ifopt/issues/40>)
  * Contributors: viviansuzano

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Tue, 19 Nov 2019 06:00:00 -0000

ros-foxy-ifopt (2.0.6-1focal) focal; urgency=high

  * Enable problems without constraints: Fix issue (#34 <https://github.com/ethz-adrl/ifopt/issues/34> , #35 <https://github.com/ethz-adrl/ifopt/issues/35>)
  * Fix/segfaults (#33 <https://github.com/ethz-adrl/ifopt/issues/33>)
  * Contributors: Wolfgang Merkt, viviansuzano

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Thu, 17 Jan 2019 06:00:00 -0000

ros-foxy-ifopt (2.0.5-1focal) focal; urgency=high

  * set default print level to 4 to show derivative test errors.
  * Improve print-out of cost terms (specifically print cost)
  * Improve docs (#27 <https://github.com/ethz-adrl/ifopt/issues/27>)
  * Implemented more efficient method for building constraint jacobian (#26 <https://github.com/ethz-adrl/ifopt/issues/26>)
  * Contributors: Alexander Winkler, fbiemueller

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 30 Jul 2018 05:00:00 -0000

ros-foxy-ifopt (2.0.4-1focal) focal; urgency=high

  * generalize ipopt solver interface, so source never has to be touched.
  * Fix/simplify image path in doxygen.
  * Simplify and generalize testing procedure (#25 <https://github.com/ethz-adrl/ifopt/issues/25>)
  * have cmake fail if IPOPT version <3.11.9
  * Install binaries to /lib/ifopt, just as catkin does.
  * Update README.md to always use make test for testing.
  * Improve doxygen (#22 <https://github.com/ethz-adrl/ifopt/issues/22>)
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Tue, 17 Jul 2018 05:00:00 -0000

ros-foxy-ifopt (2.0.3-1focal) focal; urgency=high

  * Add codefactor integration and contributing guidelines
  * display indices more precisely in printout
  * remove rsl jekins, use ros build farm
  * remove warning from version number
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Tue, 10 Jul 2018 05:00:00 -0000

ros-foxy-ifopt (2.0.2-1focal) focal; urgency=high

  * fully remove catkin dependency
  * increase cmake project version number manually
  * DRY in cmake list (reuse ${LIB_CORE})
  * Update README.md
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 02 Jul 2018 05:00:00 -0000

ros-foxy-ifopt (2.0.1-1focal) focal; urgency=high

  * make IPOPT the default ON solver option
  * Add documentation and update package.xml to use ubuntu ipopt install coinor-libipopt-dev
  * Use FindIpopt.cmake (from robotology/idyntree)
  * Set default solver to mumps, as this is free one installed in ubuntu
  * Define SNOPT/IPOPT location also through environmental variable
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Sat, 30 Jun 2018 05:00:00 -0000

ros-foxy-ifopt (2.0.0-1focal) focal; urgency=high

  * allow building with pure cmake (catkin optional) (#13 <https://github.com/ethz-adrl/ifopt/issues/13>)
  * generate ifopt-config.cmake to easily include in other cmake projects (#13 <https://github.com/ethz-adrl/ifopt/issues/13>)
  * implement pimpl idiom to avoid exporting IPOPT/SNOPT libraries/headers (#12 <https://github.com/ethz-adrl/ifopt/issues/12>)
  * Add possibility to set solver options (e.g. "ma27") on user side
  * Clean-up and improve printouts
  * Reduce to one single catkin package with solvers as cmake subdirectories
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Sun, 24 Jun 2018 05:00:00 -0000

ros-foxy-ifopt (1.0.2-1focal) focal; urgency=high

  * add correct catkin install folder for ifopt_core
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 05 Feb 2018 06:00:00 -0000

ros-foxy-ifopt (1.0.1-1focal) focal; urgency=high

  * update package xml
  * make eigen 3.2 compatible (remove header Eigen/Eigen)
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 29 Jan 2018 06:00:00 -0000

ros-foxy-ifopt (1.0.0-1focal) focal; urgency=high

  * move IPOPT and SNOPT interfaces to separate package
  * add ifopt metapackage for documentation
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Sat, 27 Jan 2018 06:00:00 -0000

ros-foxy-ifopt (0.0.2-1focal) focal; urgency=high

  * added more explanatory message in package.xml
  * added documentations badge
  * fixed bounds in example problem
  * moved CI to ros buildfarm.
  * generate tests also with catkin if installed
  * Fixed compiler warnings.
  * Contributors: Alexander W Winkler



=== debian/control ===
Source: ros-foxy-ifopt
Section: misc
Priority: optional
Maintainer: Alexander W. Winkler <alexander.w.winkler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, coinor-libipopt-dev, libeigen3-dev, ros-foxy-ros-workspace
Homepage: https://github.com/ethz-adrl/ifopt
Standards-Version: 3.9.2

Package: ros-foxy-ifopt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, coinor-libipopt-dev, libeigen3-dev, ros-foxy-ament-cmake, ros-foxy-ros-workspace
Description: An Eigen- based interface to Nonlinear Programming solver Ipopt.
 Inuitive and efficient C++ implementation of variables, costs and constraints using Eigen. Easy integration in your projects in catkin or pure cmake.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-ifopt//opt/ros/foxy/lib/:$(CURDIR)/debian/ros-foxy-ifopt//opt/ros/foxy/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
